#ifndef Map_H
#define Map_H

#include <Bild.h>
#include "Schuss.h"
#include "Ship.h"
#include "Asteroid.h"

using namespace Framework;

class Map
{
private:
	RCArray< Schuss > *schuss;
	Ship *ship;
	RCArray< Asteroid > *asteroid;
	Model2DData **aData;
	Bild **aTextur;
	Model2DData **sData;
	Bild **sTextur;
	LRahmen *kam;
	LRahmen *map;
	int shipN;
	int score;
	int breite;
	int hhe;
	int aGre;
	int mTimer;
	int maxTimer;
	double timer;
	bool beendet;
	bool rend;
	bool sr;
	int ref;

public:
	// Konstruktor
	Map();
	// Destruktor
	~Map();
	// nicht constant
	void reset();
	void doMausEreignis( MausEreignis &me );
	void doTastaturEreignis( TastaturEreignis &te );
	bool tick( double tickVal );
	void render( Bild &zRObj );
	// constant
	void speichern() const;
	int getScore() const;
	bool istBeendet() const;
	// Reference Counting
	Map *getThis();
	Map *release();
};

#endif