#ifndef Ship_H
#define Ship_H

#include <Model2D.h>
#include <Datei.h>

using namespace Framework;

class Schuss;
class Asteroid;

class Ship
{
private:
	Model2D *ship;
	Vec2< float > pos;
	Vec2< float > speed;
	int ref;

public:
	// Konstruktor
	Ship( Model2DData *data, Bild *textur, Vec2< float > p, Vec2< float > s, float r );
	// Destruktor
	~Ship();
	// nicht constant
	bool tick( double zeit, int breite, int hhe );
	void render( Bild &zRObj );
	// constant
	void save( Datei *zD ) const;
	Schuss *getSchuss() const;
	bool istTod( Asteroid *zA ) const;
	Punkt getKamPos( int breite, int hhe ) const;
	Punkt getPos() const;
	// Reference Counting
	Ship *getThis();
	Ship *release();
};

#endif